<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>TestConnectionAutoRelease xref</title>
<link type="text/css" rel="stylesheet" href="../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../testapidocs/org/apache/http/conn/TestConnectionAutoRelease.html">View Javadoc</a></div><pre>

<a class="jxr_linenumber" name="1" href="#1">1</a>   <em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="2" href="#2">2</a>   <em class="jxr_comment"> * ====================================================================</em>
<a class="jxr_linenumber" name="3" href="#3">3</a>   <em class="jxr_comment"> * Licensed to the Apache Software Foundation (ASF) under one</em>
<a class="jxr_linenumber" name="4" href="#4">4</a>   <em class="jxr_comment"> * or more contributor license agreements.  See the NOTICE file</em>
<a class="jxr_linenumber" name="5" href="#5">5</a>   <em class="jxr_comment"> * distributed with this work for additional information</em>
<a class="jxr_linenumber" name="6" href="#6">6</a>   <em class="jxr_comment"> * regarding copyright ownership.  The ASF licenses this file</em>
<a class="jxr_linenumber" name="7" href="#7">7</a>   <em class="jxr_comment"> * to you under the Apache License, Version 2.0 (the</em>
<a class="jxr_linenumber" name="8" href="#8">8</a>   <em class="jxr_comment"> * "License"); you may not use this file except in compliance</em>
<a class="jxr_linenumber" name="9" href="#9">9</a>   <em class="jxr_comment"> * with the License.  You may obtain a copy of the License at</em>
<a class="jxr_linenumber" name="10" href="#10">10</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="11" href="#11">11</a>  <em class="jxr_comment"> *   <a href="http://www.apache.org/licenses/LICENSE-2.0" target="alexandria_uri">http://www.apache.org/licenses/LICENSE-2.0</a></em>
<a class="jxr_linenumber" name="12" href="#12">12</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="13" href="#13">13</a>  <em class="jxr_comment"> * Unless required by applicable law or agreed to in writing,</em>
<a class="jxr_linenumber" name="14" href="#14">14</a>  <em class="jxr_comment"> * software distributed under the License is distributed on an</em>
<a class="jxr_linenumber" name="15" href="#15">15</a>  <em class="jxr_comment"> * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY</em>
<a class="jxr_linenumber" name="16" href="#16">16</a>  <em class="jxr_comment"> * KIND, either express or implied.  See the License for the</em>
<a class="jxr_linenumber" name="17" href="#17">17</a>  <em class="jxr_comment"> * specific language governing permissions and limitations</em>
<a class="jxr_linenumber" name="18" href="#18">18</a>  <em class="jxr_comment"> * under the License.</em>
<a class="jxr_linenumber" name="19" href="#19">19</a>  <em class="jxr_comment"> * ====================================================================</em>
<a class="jxr_linenumber" name="20" href="#20">20</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="21" href="#21">21</a>  <em class="jxr_comment"> * This software consists of voluntary contributions made by many</em>
<a class="jxr_linenumber" name="22" href="#22">22</a>  <em class="jxr_comment"> * individuals on behalf of the Apache Software Foundation.  For more</em>
<a class="jxr_linenumber" name="23" href="#23">23</a>  <em class="jxr_comment"> * information on the Apache Software Foundation, please see</em>
<a class="jxr_linenumber" name="24" href="#24">24</a>  <em class="jxr_comment"> * &lt;<a href="http://www.apache.org/&gt;." target="alexandria_uri">http://www.apache.org/&gt;.</a></em>
<a class="jxr_linenumber" name="25" href="#25">25</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="26" href="#26">26</a>  <em class="jxr_comment"> */</em>
<a class="jxr_linenumber" name="27" href="#27">27</a>  
<a class="jxr_linenumber" name="28" href="#28">28</a>  <strong class="jxr_keyword">package</strong> org.apache.http.conn;
<a class="jxr_linenumber" name="29" href="#29">29</a>  
<a class="jxr_linenumber" name="30" href="#30">30</a>  <strong class="jxr_keyword">import</strong> java.io.ByteArrayOutputStream;
<a class="jxr_linenumber" name="31" href="#31">31</a>  <strong class="jxr_keyword">import</strong> java.io.IOException;
<a class="jxr_linenumber" name="32" href="#32">32</a>  <strong class="jxr_keyword">import</strong> java.io.OutputStream;
<a class="jxr_linenumber" name="33" href="#33">33</a>  <strong class="jxr_keyword">import</strong> java.util.concurrent.TimeUnit;
<a class="jxr_linenumber" name="34" href="#34">34</a>  
<a class="jxr_linenumber" name="35" href="#35">35</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpEntity;
<a class="jxr_linenumber" name="36" href="#36">36</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpException;
<a class="jxr_linenumber" name="37" href="#37">37</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpHost;
<a class="jxr_linenumber" name="38" href="#38">38</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpRequest;
<a class="jxr_linenumber" name="39" href="#39">39</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpResponse;
<a class="jxr_linenumber" name="40" href="#40">40</a>  <strong class="jxr_keyword">import</strong> org.apache.http.MalformedChunkCodingException;
<a class="jxr_linenumber" name="41" href="#41">41</a>  <strong class="jxr_keyword">import</strong> org.apache.http.client.methods.HttpGet;
<a class="jxr_linenumber" name="42" href="#42">42</a>  <strong class="jxr_keyword">import</strong> org.apache.http.conn.routing.HttpRoute;
<a class="jxr_linenumber" name="43" href="#43">43</a>  <strong class="jxr_keyword">import</strong> org.apache.http.entity.BasicHttpEntity;
<a class="jxr_linenumber" name="44" href="#44">44</a>  <strong class="jxr_keyword">import</strong> org.apache.http.impl.DefaultHttpServerConnection;
<a class="jxr_linenumber" name="45" href="#45">45</a>  <strong class="jxr_keyword">import</strong> org.apache.http.impl.client.DefaultHttpClient;
<a class="jxr_linenumber" name="46" href="#46">46</a>  <strong class="jxr_keyword">import</strong> org.apache.http.impl.conn.PoolingClientConnectionManager;
<a class="jxr_linenumber" name="47" href="#47">47</a>  <strong class="jxr_keyword">import</strong> org.apache.http.localserver.ServerTestBase;
<a class="jxr_linenumber" name="48" href="#48">48</a>  <strong class="jxr_keyword">import</strong> org.apache.http.pool.PoolStats;
<a class="jxr_linenumber" name="49" href="#49">49</a>  <strong class="jxr_keyword">import</strong> org.apache.http.protocol.ExecutionContext;
<a class="jxr_linenumber" name="50" href="#50">50</a>  <strong class="jxr_keyword">import</strong> org.apache.http.protocol.HttpContext;
<a class="jxr_linenumber" name="51" href="#51">51</a>  <strong class="jxr_keyword">import</strong> org.apache.http.protocol.HttpRequestHandler;
<a class="jxr_linenumber" name="52" href="#52">52</a>  <strong class="jxr_keyword">import</strong> org.apache.http.util.EntityUtils;
<a class="jxr_linenumber" name="53" href="#53">53</a>  <strong class="jxr_keyword">import</strong> org.junit.Assert;
<a class="jxr_linenumber" name="54" href="#54">54</a>  <strong class="jxr_keyword">import</strong> org.junit.Test;
<a class="jxr_linenumber" name="55" href="#55">55</a>  
<a class="jxr_linenumber" name="56" href="#56">56</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../org/apache/http/conn/TestConnectionAutoRelease.html">TestConnectionAutoRelease</a> <strong class="jxr_keyword">extends</strong> <a href="../../../../org/apache/http/localserver/ServerTestBase.html">ServerTestBase</a> {
<a class="jxr_linenumber" name="57" href="#57">57</a>  
<a class="jxr_linenumber" name="58" href="#58">58</a>      @Test
<a class="jxr_linenumber" name="59" href="#59">59</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testReleaseOnEntityConsumeContent() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="60" href="#60">60</a>          PoolingClientConnectionManager mgr = <strong class="jxr_keyword">new</strong> PoolingClientConnectionManager();
<a class="jxr_linenumber" name="61" href="#61">61</a>          mgr.setDefaultMaxPerRoute(1);
<a class="jxr_linenumber" name="62" href="#62">62</a>          mgr.setMaxTotal(1);
<a class="jxr_linenumber" name="63" href="#63">63</a>  
<a class="jxr_linenumber" name="64" href="#64">64</a>          <em class="jxr_comment">// Zero connections in the pool</em>
<a class="jxr_linenumber" name="65" href="#65">65</a>          PoolStats stats = mgr.getTotalStats();
<a class="jxr_linenumber" name="66" href="#66">66</a>          Assert.assertEquals(0, stats.getAvailable());
<a class="jxr_linenumber" name="67" href="#67">67</a>  
<a class="jxr_linenumber" name="68" href="#68">68</a>          DefaultHttpClient client = <strong class="jxr_keyword">new</strong> DefaultHttpClient(mgr);
<a class="jxr_linenumber" name="69" href="#69">69</a>  
<a class="jxr_linenumber" name="70" href="#70">70</a>          <em class="jxr_comment">// Get some random data</em>
<a class="jxr_linenumber" name="71" href="#71">71</a>          HttpGet httpget = <strong class="jxr_keyword">new</strong> HttpGet(<span class="jxr_string">"/random/20000"</span>);
<a class="jxr_linenumber" name="72" href="#72">72</a>          HttpHost target = getServerHttp();
<a class="jxr_linenumber" name="73" href="#73">73</a>  
<a class="jxr_linenumber" name="74" href="#74">74</a>          HttpResponse response = client.execute(target, httpget);
<a class="jxr_linenumber" name="75" href="#75">75</a>  
<a class="jxr_linenumber" name="76" href="#76">76</a>          ClientConnectionRequest connreq = mgr.requestConnection(<strong class="jxr_keyword">new</strong> HttpRoute(target), <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="77" href="#77">77</a>          <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="78" href="#78">78</a>              connreq.getConnection(250, TimeUnit.MILLISECONDS);
<a class="jxr_linenumber" name="79" href="#79">79</a>              Assert.fail(<span class="jxr_string">"ConnectionPoolTimeoutException should have been thrown"</span>);
<a class="jxr_linenumber" name="80" href="#80">80</a>          } <strong class="jxr_keyword">catch</strong> (ConnectionPoolTimeoutException expected) {
<a class="jxr_linenumber" name="81" href="#81">81</a>          }
<a class="jxr_linenumber" name="82" href="#82">82</a>  
<a class="jxr_linenumber" name="83" href="#83">83</a>          HttpEntity e = response.getEntity();
<a class="jxr_linenumber" name="84" href="#84">84</a>          Assert.assertNotNull(e);
<a class="jxr_linenumber" name="85" href="#85">85</a>          EntityUtils.consume(e);
<a class="jxr_linenumber" name="86" href="#86">86</a>  
<a class="jxr_linenumber" name="87" href="#87">87</a>          <em class="jxr_comment">// Expect one connection in the pool</em>
<a class="jxr_linenumber" name="88" href="#88">88</a>          stats = mgr.getTotalStats();
<a class="jxr_linenumber" name="89" href="#89">89</a>          Assert.assertEquals(1, stats.getAvailable());
<a class="jxr_linenumber" name="90" href="#90">90</a>  
<a class="jxr_linenumber" name="91" href="#91">91</a>          <em class="jxr_comment">// Make sure one connection is available</em>
<a class="jxr_linenumber" name="92" href="#92">92</a>          connreq = mgr.requestConnection(<strong class="jxr_keyword">new</strong> HttpRoute(target), <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="93" href="#93">93</a>          ManagedClientConnection conn = connreq.getConnection(250, TimeUnit.MILLISECONDS);
<a class="jxr_linenumber" name="94" href="#94">94</a>  
<a class="jxr_linenumber" name="95" href="#95">95</a>          mgr.releaseConnection(conn, -1, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="96" href="#96">96</a>  
<a class="jxr_linenumber" name="97" href="#97">97</a>          mgr.shutdown();
<a class="jxr_linenumber" name="98" href="#98">98</a>      }
<a class="jxr_linenumber" name="99" href="#99">99</a>  
<a class="jxr_linenumber" name="100" href="#100">100</a>     @Test
<a class="jxr_linenumber" name="101" href="#101">101</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testReleaseOnEntityWriteTo() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="102" href="#102">102</a>         PoolingClientConnectionManager mgr = <strong class="jxr_keyword">new</strong> PoolingClientConnectionManager();
<a class="jxr_linenumber" name="103" href="#103">103</a>         mgr.setDefaultMaxPerRoute(1);
<a class="jxr_linenumber" name="104" href="#104">104</a>         mgr.setMaxTotal(1);
<a class="jxr_linenumber" name="105" href="#105">105</a> 
<a class="jxr_linenumber" name="106" href="#106">106</a>         <em class="jxr_comment">// Zero connections in the pool</em>
<a class="jxr_linenumber" name="107" href="#107">107</a>         PoolStats stats = mgr.getTotalStats();
<a class="jxr_linenumber" name="108" href="#108">108</a>         Assert.assertEquals(0, stats.getAvailable());
<a class="jxr_linenumber" name="109" href="#109">109</a> 
<a class="jxr_linenumber" name="110" href="#110">110</a>         DefaultHttpClient client = <strong class="jxr_keyword">new</strong> DefaultHttpClient(mgr);
<a class="jxr_linenumber" name="111" href="#111">111</a> 
<a class="jxr_linenumber" name="112" href="#112">112</a>         <em class="jxr_comment">// Get some random data</em>
<a class="jxr_linenumber" name="113" href="#113">113</a>         HttpGet httpget = <strong class="jxr_keyword">new</strong> HttpGet(<span class="jxr_string">"/random/20000"</span>);
<a class="jxr_linenumber" name="114" href="#114">114</a>         HttpHost target = getServerHttp();
<a class="jxr_linenumber" name="115" href="#115">115</a> 
<a class="jxr_linenumber" name="116" href="#116">116</a>         HttpResponse response = client.execute(target, httpget);
<a class="jxr_linenumber" name="117" href="#117">117</a> 
<a class="jxr_linenumber" name="118" href="#118">118</a>         ClientConnectionRequest connreq = mgr.requestConnection(<strong class="jxr_keyword">new</strong> HttpRoute(target), <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="119" href="#119">119</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="120" href="#120">120</a>             connreq.getConnection(250, TimeUnit.MILLISECONDS);
<a class="jxr_linenumber" name="121" href="#121">121</a>             Assert.fail(<span class="jxr_string">"ConnectionPoolTimeoutException should have been thrown"</span>);
<a class="jxr_linenumber" name="122" href="#122">122</a>         } <strong class="jxr_keyword">catch</strong> (ConnectionPoolTimeoutException expected) {
<a class="jxr_linenumber" name="123" href="#123">123</a>         }
<a class="jxr_linenumber" name="124" href="#124">124</a> 
<a class="jxr_linenumber" name="125" href="#125">125</a>         HttpEntity e = response.getEntity();
<a class="jxr_linenumber" name="126" href="#126">126</a>         Assert.assertNotNull(e);
<a class="jxr_linenumber" name="127" href="#127">127</a>         ByteArrayOutputStream outsteam = <strong class="jxr_keyword">new</strong> ByteArrayOutputStream();
<a class="jxr_linenumber" name="128" href="#128">128</a>         e.writeTo(outsteam);
<a class="jxr_linenumber" name="129" href="#129">129</a> 
<a class="jxr_linenumber" name="130" href="#130">130</a>         <em class="jxr_comment">// Expect one connection in the pool</em>
<a class="jxr_linenumber" name="131" href="#131">131</a>         stats = mgr.getTotalStats();
<a class="jxr_linenumber" name="132" href="#132">132</a>         Assert.assertEquals(1, stats.getAvailable());
<a class="jxr_linenumber" name="133" href="#133">133</a> 
<a class="jxr_linenumber" name="134" href="#134">134</a>         <em class="jxr_comment">// Make sure one connection is available</em>
<a class="jxr_linenumber" name="135" href="#135">135</a>         connreq = mgr.requestConnection(<strong class="jxr_keyword">new</strong> HttpRoute(target), <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="136" href="#136">136</a>         ManagedClientConnection conn = connreq.getConnection(250, TimeUnit.MILLISECONDS);
<a class="jxr_linenumber" name="137" href="#137">137</a> 
<a class="jxr_linenumber" name="138" href="#138">138</a>         mgr.releaseConnection(conn, -1, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="139" href="#139">139</a> 
<a class="jxr_linenumber" name="140" href="#140">140</a>         mgr.shutdown();
<a class="jxr_linenumber" name="141" href="#141">141</a>     }
<a class="jxr_linenumber" name="142" href="#142">142</a> 
<a class="jxr_linenumber" name="143" href="#143">143</a>     @Test
<a class="jxr_linenumber" name="144" href="#144">144</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testReleaseOnAbort() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="145" href="#145">145</a>         PoolingClientConnectionManager mgr = <strong class="jxr_keyword">new</strong> PoolingClientConnectionManager();
<a class="jxr_linenumber" name="146" href="#146">146</a>         mgr.setDefaultMaxPerRoute(1);
<a class="jxr_linenumber" name="147" href="#147">147</a>         mgr.setMaxTotal(1);
<a class="jxr_linenumber" name="148" href="#148">148</a> 
<a class="jxr_linenumber" name="149" href="#149">149</a>         <em class="jxr_comment">// Zero connections in the pool</em>
<a class="jxr_linenumber" name="150" href="#150">150</a>         PoolStats stats = mgr.getTotalStats();
<a class="jxr_linenumber" name="151" href="#151">151</a>         Assert.assertEquals(0, stats.getAvailable());
<a class="jxr_linenumber" name="152" href="#152">152</a> 
<a class="jxr_linenumber" name="153" href="#153">153</a>         DefaultHttpClient client = <strong class="jxr_keyword">new</strong> DefaultHttpClient(mgr);
<a class="jxr_linenumber" name="154" href="#154">154</a> 
<a class="jxr_linenumber" name="155" href="#155">155</a>         <em class="jxr_comment">// Get some random data</em>
<a class="jxr_linenumber" name="156" href="#156">156</a>         HttpGet httpget = <strong class="jxr_keyword">new</strong> HttpGet(<span class="jxr_string">"/random/20000"</span>);
<a class="jxr_linenumber" name="157" href="#157">157</a>         HttpHost target = getServerHttp();
<a class="jxr_linenumber" name="158" href="#158">158</a> 
<a class="jxr_linenumber" name="159" href="#159">159</a>         HttpResponse response = client.execute(target, httpget);
<a class="jxr_linenumber" name="160" href="#160">160</a> 
<a class="jxr_linenumber" name="161" href="#161">161</a>         ClientConnectionRequest connreq = mgr.requestConnection(<strong class="jxr_keyword">new</strong> HttpRoute(target), <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="162" href="#162">162</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="163" href="#163">163</a>             connreq.getConnection(250, TimeUnit.MILLISECONDS);
<a class="jxr_linenumber" name="164" href="#164">164</a>             Assert.fail(<span class="jxr_string">"ConnectionPoolTimeoutException should have been thrown"</span>);
<a class="jxr_linenumber" name="165" href="#165">165</a>         } <strong class="jxr_keyword">catch</strong> (ConnectionPoolTimeoutException expected) {
<a class="jxr_linenumber" name="166" href="#166">166</a>         }
<a class="jxr_linenumber" name="167" href="#167">167</a> 
<a class="jxr_linenumber" name="168" href="#168">168</a>         HttpEntity e = response.getEntity();
<a class="jxr_linenumber" name="169" href="#169">169</a>         Assert.assertNotNull(e);
<a class="jxr_linenumber" name="170" href="#170">170</a>         httpget.abort();
<a class="jxr_linenumber" name="171" href="#171">171</a> 
<a class="jxr_linenumber" name="172" href="#172">172</a>         <em class="jxr_comment">// Expect zero connections in the pool</em>
<a class="jxr_linenumber" name="173" href="#173">173</a>         Assert.assertEquals(0, mgr.getTotalStats().getAvailable());
<a class="jxr_linenumber" name="174" href="#174">174</a> 
<a class="jxr_linenumber" name="175" href="#175">175</a>         <em class="jxr_comment">// Make sure one connection is available</em>
<a class="jxr_linenumber" name="176" href="#176">176</a>         connreq = mgr.requestConnection(<strong class="jxr_keyword">new</strong> HttpRoute(target), <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="177" href="#177">177</a>         ManagedClientConnection conn = connreq.getConnection(250, TimeUnit.MILLISECONDS);
<a class="jxr_linenumber" name="178" href="#178">178</a> 
<a class="jxr_linenumber" name="179" href="#179">179</a>         mgr.releaseConnection(conn, -1, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="180" href="#180">180</a> 
<a class="jxr_linenumber" name="181" href="#181">181</a>         mgr.shutdown();
<a class="jxr_linenumber" name="182" href="#182">182</a>     }
<a class="jxr_linenumber" name="183" href="#183">183</a> 
<a class="jxr_linenumber" name="184" href="#184">184</a>     @Test
<a class="jxr_linenumber" name="185" href="#185">185</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testReleaseOnIOException() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="186" href="#186">186</a> 
<a class="jxr_linenumber" name="187" href="#187">187</a>         localServer.register(<span class="jxr_string">"/dropdead"</span>, <strong class="jxr_keyword">new</strong> HttpRequestHandler() {
<a class="jxr_linenumber" name="188" href="#188">188</a> 
<a class="jxr_linenumber" name="189" href="#189">189</a>             <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> handle(
<a class="jxr_linenumber" name="190" href="#190">190</a>                     <strong class="jxr_keyword">final</strong> HttpRequest request,
<a class="jxr_linenumber" name="191" href="#191">191</a>                     <strong class="jxr_keyword">final</strong> HttpResponse response,
<a class="jxr_linenumber" name="192" href="#192">192</a>                     <strong class="jxr_keyword">final</strong> HttpContext context) <strong class="jxr_keyword">throws</strong> HttpException, IOException {
<a class="jxr_linenumber" name="193" href="#193">193</a>                 BasicHttpEntity entity = <strong class="jxr_keyword">new</strong> BasicHttpEntity() {
<a class="jxr_linenumber" name="194" href="#194">194</a> 
<a class="jxr_linenumber" name="195" href="#195">195</a>                     @Override
<a class="jxr_linenumber" name="196" href="#196">196</a>                     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> writeTo(
<a class="jxr_linenumber" name="197" href="#197">197</a>                             <strong class="jxr_keyword">final</strong> OutputStream outstream) <strong class="jxr_keyword">throws</strong> IOException {
<a class="jxr_linenumber" name="198" href="#198">198</a>                         byte[] tmp = <strong class="jxr_keyword">new</strong> byte[5];
<a class="jxr_linenumber" name="199" href="#199">199</a>                         outstream.write(tmp);
<a class="jxr_linenumber" name="200" href="#200">200</a>                         outstream.flush();
<a class="jxr_linenumber" name="201" href="#201">201</a> 
<a class="jxr_linenumber" name="202" href="#202">202</a>                         <em class="jxr_comment">// do something comletely ugly in order to trigger</em>
<a class="jxr_linenumber" name="203" href="#203">203</a>                         <em class="jxr_comment">// MalformedChunkCodingException</em>
<a class="jxr_linenumber" name="204" href="#204">204</a>                         DefaultHttpServerConnection conn = (DefaultHttpServerConnection)
<a class="jxr_linenumber" name="205" href="#205">205</a>                             context.getAttribute(ExecutionContext.HTTP_CONNECTION);
<a class="jxr_linenumber" name="206" href="#206">206</a>                         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="207" href="#207">207</a>                             conn.sendResponseHeader(response);
<a class="jxr_linenumber" name="208" href="#208">208</a>                         } <strong class="jxr_keyword">catch</strong> (HttpException ignore) {
<a class="jxr_linenumber" name="209" href="#209">209</a>                         }
<a class="jxr_linenumber" name="210" href="#210">210</a>                     }
<a class="jxr_linenumber" name="211" href="#211">211</a> 
<a class="jxr_linenumber" name="212" href="#212">212</a>                 } ;
<a class="jxr_linenumber" name="213" href="#213">213</a>                 entity.setChunked(<strong class="jxr_keyword">true</strong>);
<a class="jxr_linenumber" name="214" href="#214">214</a>                 response.setEntity(entity);
<a class="jxr_linenumber" name="215" href="#215">215</a>             }
<a class="jxr_linenumber" name="216" href="#216">216</a> 
<a class="jxr_linenumber" name="217" href="#217">217</a>         });
<a class="jxr_linenumber" name="218" href="#218">218</a> 
<a class="jxr_linenumber" name="219" href="#219">219</a>         PoolingClientConnectionManager mgr = <strong class="jxr_keyword">new</strong> PoolingClientConnectionManager();
<a class="jxr_linenumber" name="220" href="#220">220</a>         mgr.setDefaultMaxPerRoute(1);
<a class="jxr_linenumber" name="221" href="#221">221</a>         mgr.setMaxTotal(1);
<a class="jxr_linenumber" name="222" href="#222">222</a> 
<a class="jxr_linenumber" name="223" href="#223">223</a>         <em class="jxr_comment">// Zero connections in the pool</em>
<a class="jxr_linenumber" name="224" href="#224">224</a>         Assert.assertEquals(0, mgr.getTotalStats().getAvailable());
<a class="jxr_linenumber" name="225" href="#225">225</a> 
<a class="jxr_linenumber" name="226" href="#226">226</a>         DefaultHttpClient client = <strong class="jxr_keyword">new</strong> DefaultHttpClient(mgr);
<a class="jxr_linenumber" name="227" href="#227">227</a> 
<a class="jxr_linenumber" name="228" href="#228">228</a>         <em class="jxr_comment">// Get some random data</em>
<a class="jxr_linenumber" name="229" href="#229">229</a>         HttpGet httpget = <strong class="jxr_keyword">new</strong> HttpGet(<span class="jxr_string">"/dropdead"</span>);
<a class="jxr_linenumber" name="230" href="#230">230</a>         HttpHost target = getServerHttp();
<a class="jxr_linenumber" name="231" href="#231">231</a> 
<a class="jxr_linenumber" name="232" href="#232">232</a>         HttpResponse response = client.execute(target, httpget);
<a class="jxr_linenumber" name="233" href="#233">233</a> 
<a class="jxr_linenumber" name="234" href="#234">234</a>         ClientConnectionRequest connreq = mgr.requestConnection(<strong class="jxr_keyword">new</strong> HttpRoute(target), <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="235" href="#235">235</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="236" href="#236">236</a>             connreq.getConnection(250, TimeUnit.MILLISECONDS);
<a class="jxr_linenumber" name="237" href="#237">237</a>             Assert.fail(<span class="jxr_string">"ConnectionPoolTimeoutException should have been thrown"</span>);
<a class="jxr_linenumber" name="238" href="#238">238</a>         } <strong class="jxr_keyword">catch</strong> (ConnectionPoolTimeoutException expected) {
<a class="jxr_linenumber" name="239" href="#239">239</a>         }
<a class="jxr_linenumber" name="240" href="#240">240</a> 
<a class="jxr_linenumber" name="241" href="#241">241</a>         HttpEntity e = response.getEntity();
<a class="jxr_linenumber" name="242" href="#242">242</a>         Assert.assertNotNull(e);
<a class="jxr_linenumber" name="243" href="#243">243</a>         <em class="jxr_comment">// Read the content</em>
<a class="jxr_linenumber" name="244" href="#244">244</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="245" href="#245">245</a>             EntityUtils.toByteArray(e);
<a class="jxr_linenumber" name="246" href="#246">246</a>             Assert.fail(<span class="jxr_string">"MalformedChunkCodingException should have been thrown"</span>);
<a class="jxr_linenumber" name="247" href="#247">247</a>         } <strong class="jxr_keyword">catch</strong> (MalformedChunkCodingException expected) {
<a class="jxr_linenumber" name="248" href="#248">248</a> 
<a class="jxr_linenumber" name="249" href="#249">249</a>         }
<a class="jxr_linenumber" name="250" href="#250">250</a> 
<a class="jxr_linenumber" name="251" href="#251">251</a>         <em class="jxr_comment">// Expect zero connections in the pool</em>
<a class="jxr_linenumber" name="252" href="#252">252</a>         Assert.assertEquals(0, mgr.getTotalStats().getAvailable());
<a class="jxr_linenumber" name="253" href="#253">253</a> 
<a class="jxr_linenumber" name="254" href="#254">254</a>         <em class="jxr_comment">// Make sure one connection is available</em>
<a class="jxr_linenumber" name="255" href="#255">255</a>         connreq = mgr.requestConnection(<strong class="jxr_keyword">new</strong> HttpRoute(target), <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="256" href="#256">256</a>         ManagedClientConnection conn = connreq.getConnection(250, TimeUnit.MILLISECONDS);
<a class="jxr_linenumber" name="257" href="#257">257</a> 
<a class="jxr_linenumber" name="258" href="#258">258</a>         mgr.releaseConnection(conn, -1, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="259" href="#259">259</a> 
<a class="jxr_linenumber" name="260" href="#260">260</a>         mgr.shutdown();
<a class="jxr_linenumber" name="261" href="#261">261</a>     }
<a class="jxr_linenumber" name="262" href="#262">262</a> 
<a class="jxr_linenumber" name="263" href="#263">263</a> }
</pre>
<hr/><div id="footer">This page was automatically generated by <a href="http://maven.apache.org/">Maven</a></div></body>
</html>

